Controllers/RecipeController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Diagnostics.Eventing.Reader;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using CoolerApplication.Models;

namespace CoolerApplication.Controllers
{
    public class RecipeController : Controller
    {
        private readonly ApplicationDbContext db = new ApplicationDbContext();

        /// <summary>
        /// method for the index page
        /// </summary>
        /// <param name="Search">get the search information and pass it trough the method</param>
        /// <returns>returns view page</returns>
        public async Task<ActionResult> Index(string Search)
        {
            List<Recipe> recipes;
            DbSet<Ingredient> ingredients = db.Ingredients;

            if (!String.IsNullOrEmpty(Search))
            {
                recipes = db.Recipes.Include(r => r.RecipeIngredients.Select(i => i.Ingredient)).Where(i => i.Name.Contains(Search)).ToList();
            }
            else
            {
                recipes = db.Recipes.Include(r => r.RecipeIngredients.Select(i => i.Ingredient)).ToList();
            }
            

            //Check if recipe can be made.
            foreach (var recipe in recipes)
            {
                int ingredientAvailable = 0;
                int ingredientUnavailable = 0;

                foreach (var recipeIngredient in recipe.RecipeIngredients)
                {
                    Ingredient ingredient = recipeIngredient.Ingredient;

                    if (ingredient.Amount < recipeIngredient.Amount)
                    {
                        recipeIngredient.EnoughIngredients = false;
                        ingredientUnavailable++;
                    }
                    else
                    {
                        recipeIngredient.EnoughIngredients = true;
                        ingredientAvailable++;
                    }
                }

                recipe.EnoughIngredients = ingredientUnavailable < 1;
            }
            return View(recipes);
        }

        /// <summary>
        /// method for the details page
        /// </summary>
        /// <param name="id">get the id of the selected recipe and pass it trough the method</param>
        /// <returns>view page</returns>
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Recipe recipe = db.Recipes.Include(r => r.RecipeIngredients.Select(i => i.Ingredient)).First(r => r.id == id);
            if (recipe == null)
            {
                return HttpNotFound();
            }

            return View(recipe);
        }

        /// <summary>
        /// method for the create view page
        /// </summary>
        /// <returns>view page</returns>
        public ActionResult Create()
        {
            ViewBag.AllIngredients = db.Ingredients.ToList();

            return View();
        }

        /// <summary>
        /// method to store the ingredient
        /// </summary>
        /// <param name="recipe">pass the model trough the method</param>
        /// <returns>returns to action index</returns>
        [HttpPost]
        public ActionResult Create(Recipe recipe)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    DbSet<Ingredient> allIngredients = db.Ingredients;
                    recipe = db.Recipes.Add(recipe);
                    db.SaveChanges();
                    recipe = db.Recipes.Include(r => r.RecipeIngredients.Select(i => i.Ingredient)).First(r => r.id == recipe.id);

                    foreach (var item in allIngredients)
                    {
                        var amountString = Request.Form["SelectedIngredients[" + item.Id + "]"];
                        if (amountString != null && amountString != "")
                        {
                            int amount = Int32.Parse(amountString);
                            if (amount > 0)
                            {
                                recipe.RecipeIngredients.Add(new RecipeIngredients
                                {
                                    RecipeId = recipe.id,
                                    Recipe = recipe,
                                    IngredientID = item.Id,
                                    Ingredient = item,
                                    Amount = amount
                                });
                            }
                        }
                    }
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
            }
            catch (RetryLimitExceededException /* dex */)
            {
                //Log the error (uncomment dex variable name and add a line here to write a log.)
                ModelState.AddModelError("",
                    "Unable to save changes. Try again, and if the problem persists, see your system administrator.");
            }

            return RedirectToAction("Index");
        }


        /// <summary>
        /// Edit method that returns the edit view
        /// </summary>
        /// <param name="id">id of the recipe</param>
        /// <returns>returns view with the recipe</returns>

        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }

            Recipe recipe = db.Recipes.Include(r=>r.RecipeIngredients.Select(ri=>ri.Ingredient)).First(r=>r.id == id);
            if (recipe == null)
            {
                return HttpNotFound();
            }

            List<List<KeyValuePair<string,string>>> list = new List<List<KeyValuePair<string, string>>>();
            var AllIngredients = db.Ingredients.ToList();
            List<int> selectedIngredientIDs = new List<int>();

            foreach (RecipeIngredients recipeIngredient in recipe.RecipeIngredients)
            {
                var tmplist = new List<KeyValuePair<string,string>>();
                tmplist.Add(new KeyValuePair<string, string>("Id", recipeIngredient.IngredientID.ToString()));
                tmplist.Add(new KeyValuePair<string, string>("Name", recipeIngredient.Ingredient.Name));
                tmplist.Add(new KeyValuePair<string, string>("Amount", recipeIngredient.Amount.ToString()));
                list.Add(tmplist);
                AllIngredients = AllIngredients.Where(i => i.Id != recipeIngredient.IngredientID).ToList();
            }

            foreach (Ingredient ingredient in AllIngredients)
            {
                var tmplist = new List<KeyValuePair<string,string>>();
                tmplist.Add(new KeyValuePair<string, string>("Id", ingredient.Id.ToString()));
                tmplist.Add(new KeyValuePair<string, string>("Name", ingredient.Name));
                tmplist.Add(new KeyValuePair<string, string>("Amount", 0.ToString()));
                list.Add(tmplist);
            }

            ViewBag.AllIngredients = list;
            ViewBag.selectedIngredientIDs = selectedIngredientIDs;

            return View(recipe);
        }


        /// <summary>
        /// method that proccesses the edited data
        /// </summary>
        /// <param name="recipeData">the recipe data with the ingredients</param>
        /// <returns>recipe update page</returns>
        [HttpPost, ActionName("Edit")]
        public ActionResult EditIngredient(Recipe recipeData)
        {
            if (recipeData.id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
             
            var recipeToUpdate = db.Recipes.Find(recipeData.id);
            if (TryUpdateModel(recipeToUpdate, "",
                new string[] {"Name"}))
            {
                try
                {
                    DbSet<Ingredient> allIngredients = db.Ingredients;
                    recipeToUpdate = db.Recipes.Include(r => r.RecipeIngredients.Select(i => i.Ingredient)).First(r => r.id == recipeToUpdate.id);
                    recipeToUpdate.RecipeIngredients.Clear();
                    foreach (var item in allIngredients)
                    {
                        var amountString = Request.Form["SelectedIngredients[" + item.Id + "]"];
                        if (amountString != null && amountString != "")
                        {
                            int amount = Int32.Parse(amountString);
                            if (amount > 0)
                            {
                                recipeToUpdate.RecipeIngredients.Add(new RecipeIngredients
                                {
                                    RecipeId = recipeToUpdate.id,
                                    Recipe = recipeToUpdate,
                                    IngredientID = item.Id,
                                    Ingredient = item,
                                    Amount = amount
                                });
                            }
                        }
                    }
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                catch (RetryLimitExceededException /* dex */)
                {
                    //Log the error (uncomment dex variable name and add a line here to write a log.
                    ModelState.AddModelError("",
                        "Unable to save changes. Try again, and if the problem persists, see your system administrator.");
                }
            }

            return View(recipeToUpdate);
        }

        /// <summary>
        /// method that redirect to delete page
        /// </summary>

Views/Recipe/Create.cshtml
@using CoolerApplication.Models
@model CoolerApplication.Models.Recipe

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@Html.Partial(
    "../Auth/_Auth"
    )

<h2>Create Recipe</h2>


@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">

        <h5>Hold Ctrl to select more than 1 ingredient</h5>

        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.RecipeIngredients, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">

                @foreach (Ingredient ingredient in ViewBag.AllIngredients)
                {
                    @ingredient.Name
                    <input type="number" name="SelectedIngredients[@ingredient.Id]" /><br />
                }

                @Html.ValidationMessageFor(model => model.RecipeIngredients, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Views/Recipe/Delete.cshtml
@model CoolerApplication.Models.Recipe

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">

    <h2>Delete Recipe</h2>

    <h3>Are you sure you want to delete this?</h3>
    <div>
        <hr />
        <dl class="dl-horizontal">
            <dt>
                @Html.DisplayNameFor(model => model.Name)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Name)
            </dd>
        </dl>

        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()

            <div class="form-actions no-color">
                <input type="submit" value="Delete" class="btn btn-danger" /> |
                @Html.ActionLink("Back to List", "Index")
            </div>
        }
    </div>
</div>

Views/Recipe/Details.cshtml
@model CoolerApplication.Models.Recipe

@{
    ViewBag.Title = "Details";
}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">

    <h2>Recipe details</h2>

    <div>
        <hr />
        <dl class="dl-horizontal">
            <dt>
                @Html.DisplayNameFor(model => model.Name)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Name)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.RecipeIngredients)
            </dt>

            <dd>
                @foreach (var ingredient in Model.RecipeIngredients)
                {
                    @Html.DisplayFor(modelItem => ingredient.Ingredient.Name)
                }
            </dd>

        </dl>
    </div>
</div>
<p>
    @Html.ActionLink("Edit", "Edit", new { id = Model.id }) |
    @Html.ActionLink("Back to List", "Index")
</p>

Views/Recipe/Edit.cshtml
@model CoolerApplication.Models.Recipe

@{
    ViewBag.Title = "Edit";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">

    <h2>Edit Recipe</h2>


    @using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()

        <div class="form-horizontal">
            <hr />
            @Html.ValidationSummary(true, "", new { @class = "text-danger" })
            @Html.HiddenFor(model => model.id)

            <div class="form-group">
                @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                @Html.LabelFor(model => model.RecipeIngredients, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">


                    @foreach (List<KeyValuePair<string, string>> ingredient in ViewBag.AllIngredients)
                    {
                        @ingredient[1].Value;
                        <input type="number" name="SelectedIngredients[@ingredient[0].Value]" value="@ingredient[2].Value" /><br />
                    }

                    @*@Html.ListBoxFor(s => s.SelectedIngredients, new MultiSelectList(ViewBag.AllIngredients, "Value", "Text", ViewBag.selectedIngredientIDs))*@

                    @Html.ValidationMessageFor(model => model.RecipeIngredients, "", new { @class = "text-danger" })

                </div>
            </div>

            <div class="form-group">
                <div class="col-md-offset-2 col-md-10">
                    <input type="submit" value="Save" class="btn btn-primary" />
                </div>
            </div>
        </div>
    }

    <div>
        @Html.ActionLink("Back to List", "Index")
    </div>
</div>
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Views/Recipe/Index.cshtml
@using System.Linq.Expressions
@using CoolerApplication.Models
@model IEnumerable<CoolerApplication.Models.Recipe>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";

}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">
    <h2>Recipes</h2>

    <p>
        @Html.ActionLink("Create New", "Create", null, new { @class = "btn btn-success m-2" })
    </p>
    <form asp-controller="Recipe" asp-action="Index">
        <p>
            <div class="form-group">
                Name:<input class="form-control" type="text" name="Search">
            </div>
            <button class="btn btn-info" type="submit">Search</button>
        </p>
    </form>
    <table class="table">
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Name)

            </th>
            <th>
                @Html.DisplayNameFor(model => model.RecipeIngredients)
            </th>

        </tr>


        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @if (item.EnoughIngredients == false)
                    {
                        <div class="text-danger">
                            @Html.DisplayFor(modelItem => item.Name)

                        </div>
                    }
                    @if (item.EnoughIngredients == true)
                    {
                        <div class="text-success">
                            @Html.DisplayFor(modelItem => item.Name)
                        </div>
                    }
                </td>

                <td>

                    @foreach (var recipeIngredients in item.RecipeIngredients)

                    {

                        var enough = recipeIngredients.EnoughIngredients ? "text-success" : "text-danger";


                        <div class="ingredient @enough">
                            @Html.DisplayFor(modelItem => recipeIngredients.Ingredient.Name)
                            (@recipeIngredients.Ingredient.Amount / @recipeIngredients.Amount)
                        </div>
                    }

                </td>
                <td>
                    @Html.ActionLink("Edit", "Edit", new { id = item.id, @class = "btn btn-primary" }) |
                    @Html.ActionLink("Details", "Details", new { id = item.id }) |
                    @Html.ActionLink("Delete", "Delete", new { id = item.id })
                </td>
            </tr>
        }
    </table>
</div>